﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SomaCalcCSharp
{

    public partial class Form1 : Form
    {
        // Atualizar localização da DLL!
        const String DLL_LOCATION = "C:\\Users\\Carlos\\Documents\\Projetos\\Colleter\\DLL\\ted.dll";

        string[] TEDStartMessages = {"Erro na abertura da porta!","Porta aberta com sucesso!"};

        ArrayList TEDs = new ArrayList();

        public delegate void TTEDConnectEvent(string ip);
        public delegate void TTEDReceiveEvent(string ip, string data, int hdr);

        [DllImport(DLL_LOCATION, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDStart(int port);

        [DllImport(DLL_LOCATION, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDBeep(string ip, int port);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDDisplaySend(string ip, string data);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDCom1On(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDCom1Off(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDCom1Send(string ip, string data);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDCom2On(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDCom2Off(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDCom2Send(string ip, string data);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDDisplayClear(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDListClear(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDListAdd(string ip, string data);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDHeaderOn(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDHeaderOff(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDDigitalOn(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDDigitalOff(string ip);

        [DllImport(DLL_LOCATION, CharSet = CharSet.Ansi, CallingConvention = CallingConvention.StdCall)]
        internal static extern int TEDDigitalRead(string ip);

        [DllImport(
            DLL_LOCATION, 
            EntryPoint = "onTEDConnect",
            CharSet = CharSet.Ansi,
            CallingConvention = CallingConvention.StdCall
            )]
        internal static extern void OnTEDConnect(TTEDConnectEvent hnd);

        [DllImport(DLL_LOCATION, 
            EntryPoint = "onTEDReceive",
            CharSet = CharSet.Ansi,
            CallingConvention = CallingConvention.StdCall)]
        internal static extern void OnTEDReceive(TTEDReceiveEvent hnd);

        public Form1()
        {
            InitializeComponent();
        }

        private void logging(string data)
        {
            Console.WriteLine(data);
        }
        private void button1_Click(object sender, EventArgs e)
        {
            OnTEDConnect(new TTEDConnectEvent(Conectado));
            OnTEDReceive(new TTEDReceiveEvent(Recebido));
            int ret = TEDStart(8);
            logging(TEDStartMessages[ret]);
        }

        private void pedeNumero(string ip)
        {
            TEDDisplaySend(ip, "numero para somar 1");
            TEDDisplaySend(ip, "numero:");
        }
        public void Conectado(string ip)
        {
            if (TEDs.IndexOf(ip) >= 0) return;
            TEDs.Add(ip);
            logging(ip + " conectado!");
            TEDDisplayClear(ip);
            pedeNumero(ip);
        }
        public void Recebido(string ip, string data, int hdr)
        {
            logging("Recebido " + data + " de " + ip + " com header: " + hdr.ToString());

            int num;
            if (int.TryParse(data, out num))
            {
                TEDDisplaySend(ip, "soma: " + (num + 1).ToString());
            }
            pedeNumero(ip);
        }

        private void button2_Click(object sender, EventArgs e)
        {
        }
    }
}
